GNU Radio's GSM Package: ViterbiTCH_AFS12_2 Class Reference

GNU Radio's GSM Package

Classes | Public Types | Public Member Functions | List of all members
ViterbiTCH_AFS12_2 Class Reference

`#include <AmrCoder.h>`

Inheritance diagram for ViterbiTCH_AFS12_2:

## Classes
struct | candStruct

## Public Types
typedef struct ViterbiTCH_AFS12_2::candStruct | vCand

## Public Member Functions
void | vitClear (vCand &v)
unsigned | iRate () const
uint32_t | cMask () const
uint32_t | stateTable (unsigned g, unsigned i) const
unsigned | deferral () const
| ViterbiTCH_AFS12_2 ()
void | initializeStates ()
const vCand & | step (uint32_t inSample, const float *probs, const float *iprobs)
Public Member Functions inherited from ViterbiBase
virtual int | getBEC ()
unsigned | applyPoly (uint64_t val, uint64_t poly)
unsigned | applyPoly (uint64_t val, uint64_t poly, unsigned order)

## Detailed Description

Class to represent recursive systematic convolutional coders/decoders of rate 1/2, memory length 4.

## Member Typedef Documentation

## ◆ vCand

typedef struct ViterbiTCH_AFS12_2::candStruct ViterbiTCH_AFS12_2::vCand

A candidate sequence in a Viterbi decoder. The 32-bit state register can support a deferral of 6 with a 4th-order coder.

## Constructor & Destructor Documentation

## ◆ ViterbiTCH_AFS12_2()

ViterbiTCH_AFS12_2::ViterbiTCH_AFS12_2 | ( |  | ) |

Referenced by deferral().

## Member Function Documentation

## ◆ cMask()

uint32_t ViterbiTCH_AFS12_2::cMask | ( |  | ) | const
| inline

## ◆ deferral()

unsigned ViterbiTCH_AFS12_2::deferral | ( |  | ) | const
| inline

References initializeStates(), step(), and ViterbiTCH_AFS12_2().

## ◆ initializeStates()

void ViterbiTCH_AFS12_2::initializeStates | ( |  | ) |

Set all cost metrics to zero.

Referenced by deferral(), ViterbiTCH_AFS10_2::deferral(), ViterbiTCH_AFS7_95::deferral(), ViterbiTCH_AFS7_4::deferral(), ViterbiTCH_AFS6_7::deferral(), ViterbiTCH_AFS5_9::deferral(), ViterbiTCH_AFS5_15::deferral(), and ViterbiTCH_AFS4_75::deferral().

## ◆ iRate()

unsigned ViterbiTCH_AFS12_2::iRate | ( |  | ) | const
| inline

## ◆ stateTable()

uint32_t ViterbiTCH_AFS12_2::stateTable | ( | unsigned | g,
|  | unsigned | i
| ) |  | const
| inline

## ◆ step()

const vCand& ViterbiTCH_AFS12_2::step | ( | uint32_t | inSample,
|  | const float * | probs,
|  | const float * | iprobs
| ) |  |

Full cycle of the Viterbi algorithm: branch, metrics, prune, select.

Returns
  reference to minimum-cost candidate.

Referenced by deferral(), ViterbiTCH_AFS10_2::deferral(), ViterbiTCH_AFS7_95::deferral(), ViterbiTCH_AFS7_4::deferral(), ViterbiTCH_AFS6_7::deferral(), ViterbiTCH_AFS5_9::deferral(), ViterbiTCH_AFS5_15::deferral(), and ViterbiTCH_AFS4_75::deferral().

## ◆ vitClear()

void ViterbiTCH_AFS12_2::vitClear | ( | vCand & | v | ) |
| inline

Clear a structure.

References ViterbiTCH_AFS12_2::candStruct::cost, ViterbiTCH_AFS12_2::candStruct::iState, ViterbiTCH_AFS12_2::candStruct::oState, and ViterbiTCH_AFS12_2::candStruct::rState.

The documentation for this class was generated from the following file:

- AmrCoder.h